"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Autocomplete = void 0;
var react_1 = __importStar(require("react"));
var AutocompletePure_1 = require("../AutocompletePure");
var Input_1 = require("../Input");
var InputAutoComplete = react_1.default.forwardRef(function InputAutoComplete(_a, ref) {
    var _handleInputChange = _a._handleInputChange, _openAutoComplete = _a._openAutoComplete, _closeAutoComplete = _a._closeAutoComplete, _loading = _a._loading, cleanAfterSelect = _a.cleanAfterSelect, onSelect = _a.onSelect, rest = __rest(_a, ["_handleInputChange", "_openAutoComplete", "_closeAutoComplete", "_loading", "cleanAfterSelect", "onSelect"]);
    var inputRef = (0, react_1.useRef)();
    (0, react_1.useImperativeHandle)(ref, function () { return ({
        onSelect: function (item) {
            if (cleanAfterSelect) {
                inputRef.current.value = '';
                if (rest.onInput)
                    rest.onInput('');
            }
            else {
                inputRef.current.value = item.name;
                if (rest.onInput)
                    rest.onInput(item.name);
            }
        },
    }); });
    function onInput(value) {
        _handleInputChange(value);
        if (rest.onInput)
            rest.onInput(value);
    }
    function onFocus(e) {
        _openAutoComplete();
        if (rest.onFocus)
            rest.onFocus(e);
    }
    function onBlur(e) {
        _closeAutoComplete();
        if (rest.onBlur)
            rest.onBlur(e);
    }
    return (react_1.default.createElement(Input_1.Input, __assign({}, rest, { ref: inputRef, onInput: onInput, onFocus: onFocus, onBlur: onBlur, loading: _loading, "data-testid": "autocomplete--input" })));
});
exports.Autocomplete = (0, react_1.forwardRef)(function Autocomplete(props, ref) {
    return react_1.default.createElement(AutocompletePure_1.AutocompletePure, __assign({}, props, { as: InputAutoComplete, ref: ref }));
});
//# sourceMappingURL=Autocomplete.js.map