"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Radio = exports.RadioPure = void 0;
var react_1 = __importStar(require("react"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var Radio_style_1 = __importDefault(require("./Radio.style"));
var RadioCore_1 = require("./RadioCore");
exports.RadioPure = react_1.default.forwardRef(function RadioPure(_a, inputRef) {
    var value = _a.value, onChange = _a.onChange, options = _a.options, title = _a.title, defaultValue = _a.defaultValue, error = _a.error, color = _a.color, rightRadio = _a.rightRadio, as = _a.as, rest = __rest(_a, ["value", "onChange", "options", "title", "defaultValue", "error", "color", "rightRadio", "as"]);
    var inputRefs = (0, react_1.useRef)([]);
    (0, react_1.useImperativeHandle)(inputRef, function () { return inputRefs.current; }, []);
    return (react_1.default.createElement(Radio_style_1.default, { color: color },
        options.map(function (option, index) {
            return (react_1.default.createElement("div", { className: "radio-container", key: "radio-".concat(index) },
                react_1.default.createElement("label", { className: "radio-container radio-label clean" },
                    react_1.default.createElement("input", __assign({ ref: function (elRef) {
                            inputRefs.current[index] = elRef;
                        }, type: "radio", disabled: option.disabled, checked: value !== undefined ? (0, isEqual_1.default)(option.value, value) : undefined, defaultChecked: value === undefined ? (0, isEqual_1.default)(defaultValue, option.value) : undefined }, rest, { onChange: function () {
                            if (onChange) {
                                onChange(option.value);
                            }
                        }, "data-testid": "radio-".concat(index) })),
                    react_1.default.createElement("span", { className: "radio ".concat(error && 'has-error', " ").concat(option.disabled && 'disabled', " ").concat(rightRadio && 'right'), "data-testid": "input-radio-circle-".concat(index) }),
                    react_1.default.createElement("span", { className: "title ".concat(option.disabled && 'disabled', " ").concat(rightRadio && 'right') }, option.name))));
        }),
        error && (react_1.default.createElement("div", { className: "error-input", "data-testid": "input-error" }, error))));
});
exports.Radio = react_1.default.forwardRef(function Checkbox(props, inputRef) {
    var ref = (0, react_1.useRef)();
    (0, react_1.useImperativeHandle)(inputRef, function () { return ref.current; }, []);
    return react_1.default.createElement(RadioCore_1.RadioCore, __assign({}, props, { ref: ref, as: exports.RadioPure }));
});
//# sourceMappingURL=Radio.js.map