"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnformInput = void 0;
var react_1 = __importStar(require("react"));
var useDidUpdateEffect_1 = require("@devesharp/react-hooks/lib/useDidUpdateEffect");
var unform_core_1 = require("@devesharp/unform-core");
exports.UnformInput = react_1.default.forwardRef(function UnformInput(props, inputRef) {
    var _a = (0, unform_core_1.useField)(props.name), fieldName = _a.fieldName, registerField = _a.registerField, _b = _a.defaultValue, defaultValue = _b === void 0 ? null : _b, error = _a.error, clearError = _a.clearError;
    var ref = (0, react_1.useRef)({
        value: defaultValue !== null && defaultValue !== void 0 ? defaultValue : null,
    });
    (0, react_1.useImperativeHandle)(inputRef, function () { return ref.current; }, []);
    (0, react_1.useEffect)(function () {
        if (props.onError)
            props.onError(error);
    }, [error]);
    (0, react_1.useEffect)(function () {
        var _a;
        (_a = props.onInitValue) === null || _a === void 0 ? void 0 : _a.call(props, defaultValue);
    }, []);
    (0, useDidUpdateEffect_1.useDidUpdateEffect)(function () {
        if (error) {
            clearError();
        }
    }, [props.value]);
    (0, react_1.useEffect)(function () {
        if (props.value !== undefined) {
            ref.current.value = props.value;
        }
    }, [props.value]);
    (0, react_1.useEffect)(function () {
        if (props.value !== undefined) {
            ref.current.value = props.value;
        }
    }, []);
    (0, react_1.useEffect)(function () {
        registerField({
            name: fieldName,
            ref: ref,
            path: 'current',
            clearValue: function (_ref) {
                ref.current.value = null;
                if (props.onChange)
                    props.onChange(null);
            },
            setValue: function (_ref, value) {
                ref.current.value = value;
                if (props.onChange)
                    props.onChange(value);
            },
            getValue: function (_ref) {
                var _a, _b, _c;
                return (_c = (_b = (_a = ref.current) === null || _a === void 0 ? void 0 : _a.getValue) === null || _b === void 0 ? void 0 : _b.call(_a)) !== null && _c !== void 0 ? _c : ref.current.value;
            },
        });
    }, [fieldName, registerField]);
    return null;
});
//# sourceMappingURL=UnformInput.js.map